#include "cv.h"
#include "highgui.h"
#include <math.h>
#include "stdio.h"




int* cvHist(IplImage *Obr, int visible);
//vraci ukazatel na pole velikosti 256, kde kazdy prvek obsahuje cetnost daneho jasu v obraze
//provede vypocet histogramu z obrazu Obr
//promenna visible udava jestli se ma zobrazovat histogram =1 ci nikoliv =0

IplImage* cvImageAdjust(IplImage *Obr,double x1,double y1,double x2,double y2);
//provede zmenu jasu obrazu
//parametry jsou obraz, vysledek, souradnice primky, podle niz jas menime

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez);
//proved rotaci obrazu Obr o uhel uhel
//jestlize orez=0 pak bude vyseldny obraz vetsi nez vzorovy ovsem cely, jinak se obraz orizne
//na velikost originalu

int main( int argc, char** argv )
{
	IplImage *obr;
	IplImage *vys;
	IplImage *gray;
	IplImage *graypom;
	IplImage *obrconvert;
	IplImage *H;

	int c,i,k;

	cvNamedWindow( "Okno",1);//vytvori okno na ktere se odkazujeme pomoci jmena
	
	

	obr = cvLoadImage ( "jpg.jpg",-1);//nacte obraz
	obrconvert = cvCreateImage (cvGetSize(obr),8 ,3);//obraz pro barevne reprezentace
	H = cvCreateImage (cvGetSize(obr),8 ,1);//obraz pro barevne reprezentace
	vys = cvCreateImage (cvGetSize(obr),IPL_DEPTH_64F ,1);
	graypom = cvCreateImage ( cvGetSize(obr), 8 , 1);// vztvoreni hlavycky obrazu a alokovani pameti 
	gray = cvCreateImage ( cvGetSize(obr), IPL_DEPTH_64F , 1);// vztvoreni hlavycky obrazu a alokovani pameti 

	cvCvtColor( obr, graypom, CV_BGR2GRAY);//prevod na sedotonovy
	cvConvertScale(graypom,gray,1,0);//pro vypocet fourierova obrazu je nutne prekovnertovat obraz do IPL_DEPTH_64F viz Help

	printf("**stiskni klavesu**\n");
	cvShowImage("Okno",graypom);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	printf("DCT transformace\n");
	printf("**stiskni klavesu**\n");
	cvDFT(gray,vys,CV_DXT_FORWARD);//vypocet fourierova obrazu
	
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	//k obrazum v jinem formatu ne 8 bitu na pixel se musi pristupovat pomoci funkce cvGetReal2D a cvSetReal2D
	for (i=0;i<vys->height;i++){//filtrace obrazu
		for (k=0;k<vys->width;k++){
			if (sqrt((i)*(i)+(k)*(k))>50){
				cvSetReal2D(vys,i,k,0);
				//vys->imageData[k+i*vys->widthStep]=0;
			}
		}
	}
	printf("odstraneni vysokych frekvenci\n");
	printf("**stiskni klavesu**\n");
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach

	cvDFT(vys,gray,CV_DXT_INV_SCALE);//zpetna fourierova transformace

	cvConvertScale(gray,graypom,1,0);//prevod zpet na osmi bitovo reprezentaci obrazu
	printf("zpetny prevod na obraz\n");
	printf("**stiskni klavesu**\n");
	
	cvShowImage("Okno",graypom);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	printf("barevne reprezentace chromaticke barvy\n");
	printf("**stiskni klavesu**\n");
	cvCvtColor( obr, obrconvert,CV_RGB2YCrCb);//prevod na chromaticke bravy
	cvShowImage("Okno",obrconvert);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	printf("barevne reprezentace HSV\n");
	printf("**stiskni klavesu**\n");
	cvCvtColor( obr, obrconvert,CV_RGB2HSV );//prevod na HSV reprezentaci
	cvShowImage("Okno",obrconvert);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	printf("barevne reprezentace pouze H slozka\n");
	printf("**stiskni klavesu**\n");
	cvSplit( obrconvert, NULL, H, NULL, NULL);//vybrani pouze jedne slozky obrazu
	cvShowImage("Okno",H);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	



	
    cvDestroyWindow("Okno");//uvolneni okna    
	cvReleaseImage(&obr);//uvolneni pameti
	cvReleaseImage(&H);//uvolneni pameti
	cvReleaseImage(&obrconvert);//uvolneni pameti
	cvReleaseImage(&vys);//uvolneni pameti
	cvReleaseImage(&gray);//uvolneni pameti



    return 0;
}




int* cvHist(IplImage *Obr, int visible)
//vypocet histogramu
{
	int i,j,max=0;
	int *Hist;//pole pro umisteni hodnot histogramu
	IplImage *Histogram;
	int range=256;//pocet jasu
	int c;

	//alokace pameti pro histogram a jeho vynulovani
	Hist = (int*) malloc(sizeof(int)*range);
	for (i=0;i<range;i++){
		Hist[i]=0;//vynulovani histgramu
	}


	for (i=0;i<Obr->height;i++){
		for (j=0;j<Obr->width;j++){
			Hist[(unsigned char)Obr->imageData[j+i*Obr->width]]++;//inkrementace prislusneho jasu
		}
	}

	if (visible==1){
		cvNamedWindow( "Histogram", 1 );
		for (i=0;i<=range;i++){
			if (max<Hist[i]){
				max=Hist[i];
			}
		}
		Histogram= cvCreateImage( cvSize(range,300),8,1);//vytvori obraz pro zobrazeni histogramu 300 cely histogram se musi max/300
		for (i=0;i<=range;i++){
			cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,300),cvRealScalar(255),0,8,0);
			cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,0),cvRealScalar(0),0,8,0);
		}
		cvShowImage( "Histogram", Histogram);
		c = cvWaitKey(0);//cekani na klavesu v milisekundach
		cvDestroyWindow("Histogram");
		cvReleaseImage(&Histogram);
	}
	return(Hist);
}

IplImage* cvImageAdjust(IplImage *Obr, double x1,double y1,double x2,double y2)
{
	double k,q;//parametry primky
	int pole[256];//prepocet hodnot
	int i,j;
	IplImage *Vys;

	Vys = cvCreateImage( cvGetSize(Obr),8,Obr->nChannels);
	k=(y2-y1)/(x2-x1);
	q=y1-k*x1;
	for (i=0;i<256;i++){
		if (k*i/256+q<0){
			pole[i]=(unsigned char)0;
		}
		else{
			if (k*i/256+q>1){
				pole[i]=(unsigned char)255;
			}
			else{
				pole[i]=(unsigned char)(1+(k*i/256+q)*255);
			}
		}
	}
	for (i=0;i<Obr->widthStep;i++){
		for (j=0;j<Obr->height;j++){
			Vys->imageData[j*Obr->widthStep+i]=pole[(unsigned char)Obr->imageData[j*Obr->widthStep+i]];
		}
	}
	return (Vys);
}

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez)
{
	float m[6];
    CvMat M = cvMat( 2, 3, CV_32F, m );
    double prep;
	int vyska;
	int sirka;
	double uhelpom;
	IplImage *Vys;
	 
	
	if (orez==0){//obraz se zvetsi
		uhelpom=atan((double)(Obr->height/2)/(double)(Obr->width/2));//vypocita se pomocny uhel 
		prep=sqrt(Obr->width*Obr->width+Obr->height*Obr->height)/2;
		if (sin(uhelpom+uhel*CV_PI/180.)*prep>sin(uhelpom-uhel*CV_PI/180.)*prep){
			vyska=sin(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			vyska=sin(uhelpom-uhel*CV_PI/180.)*prep;
		}
		if (cos(uhelpom+uhel*CV_PI/180.)*prep>cos(uhelpom-uhel*CV_PI/180.)*prep){
			sirka=cos(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			sirka=cos(uhelpom-uhel*CV_PI/180.)*prep;
		}
		Vys= cvCreateImage( cvSize(sirka*2,vyska*2),8,Obr->nChannels);//vytvoreni vysledneho obrazu
	}
	else{
		Vys= cvCloneImage( Obr);//vytvoreni vysledneho obrazu
	}
	m[0] = (float)(cos(-uhel*CV_PI/180.));
    m[1] = (float)(sin(-uhel*CV_PI/180.));
    m[2] = Obr->width*0.5f;
    m[3] = -m[1];
    m[4] = m[0];
    m[5] = Obr->height*0.5f;

	

    cvGetQuadrangleSubPix( Obr, Vys, &M, 1, cvScalarAll(0));//provede se rotace
	
    return(Vys);
}

